package com.szhis.frsoft.his.service.outdateItem;

import java.util.Iterator;
import com.szhis.frsoft.common.utils.IntegerUtils;
import com.szhis.frsoft.fr.LoginUser;
import java.math.BigDecimal;
import com.szhis.frsoft.entity.his.mzys.MZYZZX;
import com.szhis.frsoft.common.utils.BigDecimalUtils;
import java.io.Serializable;
import com.szhis.frsoft.common.utils.JPAUtils;
import com.szhis.frsoft.entity.pub.dict.DictConst;
import java.util.Date;
import com.szhis.frsoft.vip.bo.ItemReplacementBO;
import java.util.List;
import com.szhis.frsoft.entity.his.mzys.MZYZCS;
import com.szhis.frsoft.entity.his.mzsf.MZSFDSFXMMX;
import com.szhis.frsoft.repository.his.mzys.MZYZZXDao;
import org.springframework.beans.factory.annotation.Autowired;
import com.szhis.frsoft.repository.his.mzys.MZYZCSDao;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.stereotype.Service;

@Service
@Transactional
public class OutDateItemManageService
{
    @Autowired
    private MZYZCSDao mzyzcsDao;
    @Autowired
    private MZYZZXDao mzyzzxDao;
    
    private MZYZCS createMZYZCSIfNotExists(final MZSFDSFXMMX sfdsfxm) {
        return this.mzyzcsDao.createIfNotExists(sfdsfxm);
    }
    
    public void expireOutDatedItem(final List<ItemReplacementBO> outdatedItems) {
        final Date now = new Date();
        for (final ItemReplacementBO item : outdatedItems) {
            if (DictConst.Int_3.equals(item.getLx())) {
                continue;
            }
            final Integer lsh = item.getLsh();
            MZYZCS mzyzcs;
            Integer zxksidKSid;
            if (DictConst.Int_1.equals(item.getLx())) {
                final MZSFDSFXMMX sfxmFymx = (MZSFDSFXMMX)JPAUtils.findOne((Class)MZSFDSFXMMX.class, (Serializable)lsh);
                mzyzcs = this.createMZYZCSIfNotExists(sfxmFymx);
                final BigDecimal sl = sfxmFymx.getSl();
                sfxmFymx.setYzxsl(sl);
                JPAUtils.update((Object)sfxmFymx);
                zxksidKSid = sfxmFymx.getZxksidKSid();
            }
            else {
                mzyzcs = (MZYZCS)JPAUtils.findOne((Class)MZYZCS.class, (Serializable)lsh);
                zxksidKSid = mzyzcs.getkSid();
            }
            final BigDecimal sycs = mzyzcs.getSycs();
            if (BigDecimalUtils.isPositive(sycs)) {
                final MZYZZX mzyzzx = new MZYZZX();
                mzyzzx.setbRJBXXid(mzyzcs.getbRJBXXid());
                mzyzzx.setZxzt(DictConst.ZXQK_执行完成);
                mzyzzx.setyZCSlsh(mzyzcs.getLsh());
                mzyzzx.setyZDMXlsh(mzyzcs.getyZDMXlsh());
                mzyzzx.setBccs(sycs);
                mzyzzx.setSycs(BigDecimal.ZERO);
                mzyzzx.setJdsj(now);
                mzyzzx.setBdsj(now);
                mzyzzx.setZxsj(now);
                mzyzzx.setkSid(zxksidKSid);
                mzyzzx.setApsj(now);
                mzyzzx.setWcsj(now);
                mzyzzx.setLrrYGid(LoginUser.getyGid());
                mzyzzx.setJdrYGid(LoginUser.getyGid());
                mzyzzx.setLrsj(now);
                mzyzzx.setXgsj(now);
                mzyzzx.setkSid(mzyzcs.getkSid());
                mzyzzx.setBz("过期项目作废扣减剩余次数");
                mzyzzx.setSffylsr(DictConst.Int_2);
                mzyzzx.setBzw(Integer.valueOf(IntegerUtils.bitOn(Integer.valueOf(0), 2)));
                JPAUtils.save((Object)mzyzzx);
            }
            mzyzcs.setSycs(BigDecimal.ZERO);
            JPAUtils.update((Object)mzyzcs);
        }
    }
    
    public void revokeOutDateItem(final List<ItemReplacementBO> outdatedItems) {
        final Date now = new Date();
        for (final ItemReplacementBO item : outdatedItems) {
            if (!DictConst.Int_3.equals(item.getLx())) {
                continue;
            }
            final Integer lsh = item.getLsh();
            final MZYZZX origin_mzyzzx = (MZYZZX)this.mzyzzxDao.findOne((Serializable)lsh);
            final MZYZCS mzyzcs = (MZYZCS)this.mzyzcsDao.findOne((Serializable)origin_mzyzzx.getyZCSlsh());
            final MZSFDSFXMMX sfxmFymx = (MZSFDSFXMMX)JPAUtils.findOne((Class)MZSFDSFXMMX.class, (Serializable)mzyzcs.getsFDSFXMMXlsh());
            final Integer zxksidKSid = mzyzcs.getkSid();
            final BigDecimal sl = origin_mzyzzx.getBccs();
            if (BigDecimalUtils.isPositive(sl)) {
                final MZYZZX mzyzzx = new MZYZZX();
                mzyzzx.setyZCSlsh(mzyzcs.getLsh());
                mzyzzx.setBccs(sl.negate());
                mzyzzx.setbRJBXXid(mzyzcs.getbRJBXXid());
                mzyzzx.setZxzt(DictConst.ZXQK_拒绝执行);
                mzyzzx.setyZDMXlsh(mzyzcs.getyZDMXlsh());
                mzyzzx.setSycs(BigDecimal.ZERO);
                mzyzzx.setJdsj(now);
                mzyzzx.setZxsj(now);
                mzyzzx.setkSid(zxksidKSid);
                mzyzzx.setWcsj(now);
                mzyzzx.setLrrYGid(LoginUser.getyGid());
                mzyzzx.setLrsj(now);
                mzyzzx.setXgsj(now);
                mzyzzx.setkSid(mzyzcs.getkSid());
                mzyzzx.setBz("撤销过期项目作废。");
                mzyzzx.setSffylsr(DictConst.Int_2);
                mzyzzx.setBzw(Integer.valueOf(IntegerUtils.bitOn(Integer.valueOf(0), 2)));
                mzyzzx.setyZZXlsh(origin_mzyzzx.getLsh());
                JPAUtils.save((Object)mzyzzx);
                origin_mzyzzx.setyZZXlsh(mzyzzx.getLsh());
            }
            mzyzcs.setSycs(mzyzcs.getSycs().add(sl));
            JPAUtils.update((Object)mzyzcs);
            if (sfxmFymx == null) {
                continue;
            }
            sfxmFymx.setYzxsl(sfxmFymx.getYzxsl().subtract(sl));
            JPAUtils.update((Object)sfxmFymx);
        }
    }
    
    public void delayItemExpirationTime(final List<ItemReplacementBO> outdatedItems, final Date date) {
        for (final ItemReplacementBO item : outdatedItems) {
            final Integer lsh = item.getLsh();
            if (item.getLx() == 1) {
                final MZSFDSFXMMX mzsfdsfxmmx = (MZSFDSFXMMX)JPAUtils.findOne((Class)MZSFDSFXMMX.class, (Serializable)lsh);
                if (mzsfdsfxmmx != null) {
                    mzsfdsfxmmx.setXfjzsj(date);
                    JPAUtils.update((Object)mzsfdsfxmmx);
                }
                final List<MZYZCS> listcs = JPAUtils.query("select cs from MZYZCS cs where cs.bRJBXXid = ?1 and cs.sFDSFXMMXlsh = ?2", new Object[] { item.getBrid(), lsh });
                if (listcs.size() == 0) {
                    continue;
                }
                final MZYZCS mzyzcs = listcs.get(0);
                mzyzcs.setYxrq(date);
                JPAUtils.update((Object)mzyzcs);
            }
            else {
                final MZYZCS mzyzcs = (MZYZCS)JPAUtils.findOne((Class)MZYZCS.class, (Serializable)lsh);
                if (mzyzcs == null) {
                    continue;
                }
                mzyzcs.setYxrq(date);
                JPAUtils.update((Object)mzyzcs);
                final MZSFDSFXMMX mzsfdsfxmmx = (MZSFDSFXMMX)JPAUtils.findOne((Class)MZSFDSFXMMX.class, (Serializable)mzyzcs.getsFDSFXMMXlsh());
                if (mzsfdsfxmmx == null) {
                    continue;
                }
                mzsfdsfxmmx.setXfjzsj(date);
                JPAUtils.update((Object)mzsfdsfxmmx);
            }
        }
    }
}
